Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2269)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2270)
@@ -2416,6 +2666,6 @@
 !
 !--    Horizontal surfaces
-       ALLOCATE ( m_liq_eb_h_1%var_1d(1:surf_lsm_h%ns)                   )
-       ALLOCATE ( m_liq_eb_h_2%var_1d(1:surf_lsm_h%ns)                   )
+       ALLOCATE ( m_liq_h_1%var_1d(1:surf_lsm_h%ns)                   )
+       ALLOCATE ( m_liq_h_2%var_1d(1:surf_lsm_h%ns)                   )
        ALLOCATE ( t_surface_h_1%var_1d(1:surf_lsm_h%ns)                  )
        ALLOCATE ( t_surface_h_2%var_1d(1:surf_lsm_h%ns)                  )
@@ -2427,6 +2677,6 @@
 !--    Vertical surfaces
        DO  l = 0, 3
-          ALLOCATE ( m_liq_eb_v_1(l)%var_1d(1:surf_lsm_v(l)%ns)                   )
-          ALLOCATE ( m_liq_eb_v_2(l)%var_1d(1:surf_lsm_v(l)%ns)                   )
+          ALLOCATE ( m_liq_v_1(l)%var_1d(1:surf_lsm_v(l)%ns)                   )
+          ALLOCATE ( m_liq_v_2(l)%var_1d(1:surf_lsm_v(l)%ns)                   )
           ALLOCATE ( t_surface_v_1(l)%var_1d(1:surf_lsm_v(l)%ns)                  )
           ALLOCATE ( t_surface_v_2(l)%var_1d(1:surf_lsm_v(l)%ns)                  )
@@ -2441,5 +2691,5 @@
 !--    Allocate intermediate timestep arrays
 !--    Horizontal surfaces
-       ALLOCATE ( tm_liq_eb_h_m%var_1d(1:surf_lsm_h%ns)                  )
+       ALLOCATE ( tm_liq_h_m%var_1d(1:surf_lsm_h%ns)                  )
        ALLOCATE ( tt_surface_h_m%var_1d(1:surf_lsm_h%ns)                 )
        ALLOCATE ( tm_soil_h_m%var_2d(nzb_soil:nzt_soil,1:surf_lsm_h%ns)  )
@@ -2448,5 +2698,5 @@
 !--    Horizontal surfaces
        DO  l = 0, 3
-          ALLOCATE ( tm_liq_eb_v_m(l)%var_1d(1:surf_lsm_v(l)%ns)                  )
+          ALLOCATE ( tm_liq_v_m(l)%var_1d(1:surf_lsm_v(l)%ns)                  )
           ALLOCATE ( tt_surface_v_m(l)%var_1d(1:surf_lsm_v(l)%ns)                 )
           ALLOCATE ( tm_soil_v_m(l)%var_2d(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)  )
@@ -2463,27 +2713,22 @@
 !--    Allocate 2D vegetation model arrays
 !--    Horizontal surfaces
-       ALLOCATE ( surf_lsm_h%alpha_vg(1:surf_lsm_h%ns)         )
        ALLOCATE ( surf_lsm_h%building_surface(1:surf_lsm_h%ns) )
        ALLOCATE ( surf_lsm_h%c_liq(1:surf_lsm_h%ns)            )
+       ALLOCATE ( surf_lsm_h%c_surface(1:surf_lsm_h%ns)        )
        ALLOCATE ( surf_lsm_h%c_veg(1:surf_lsm_h%ns)            )
        ALLOCATE ( surf_lsm_h%f_sw_in(1:surf_lsm_h%ns)          )
-       ALLOCATE ( surf_lsm_h%ghf_eb(1:surf_lsm_h%ns)           )
-       ALLOCATE ( surf_lsm_h%gamma_w_sat(1:surf_lsm_h%ns)      )
+       ALLOCATE ( surf_lsm_h%ghf(1:surf_lsm_h%ns)              )
        ALLOCATE ( surf_lsm_h%g_d(1:surf_lsm_h%ns)              )
        ALLOCATE ( surf_lsm_h%lai(1:surf_lsm_h%ns)              )
-       ALLOCATE ( surf_lsm_h%l_vg(1:surf_lsm_h%ns)             )
+       ALLOCATE ( surf_lsm_h%lambda_h_def(1:surf_lsm_h%ns)     )
        ALLOCATE ( surf_lsm_h%lambda_surface_u(1:surf_lsm_h%ns) )
        ALLOCATE ( surf_lsm_h%lambda_surface_s(1:surf_lsm_h%ns) )
-       ALLOCATE ( surf_lsm_h%m_fc(1:surf_lsm_h%ns)             )
-       ALLOCATE ( surf_lsm_h%m_res(1:surf_lsm_h%ns)            )
-       ALLOCATE ( surf_lsm_h%m_sat(1:surf_lsm_h%ns)            )
-       ALLOCATE ( surf_lsm_h%m_wilt(1:surf_lsm_h%ns)           )
-       ALLOCATE ( surf_lsm_h%n_vg(1:surf_lsm_h%ns)             )
-       ALLOCATE ( surf_lsm_h%pave_surface(1:surf_lsm_h%ns)     )
-       ALLOCATE ( surf_lsm_h%qsws_eb(1:surf_lsm_h%ns)          )
-       ALLOCATE ( surf_lsm_h%qsws_soil_eb(1:surf_lsm_h%ns)     )
-       ALLOCATE ( surf_lsm_h%qsws_liq_eb(1:surf_lsm_h%ns)      )
-       ALLOCATE ( surf_lsm_h%qsws_veg_eb(1:surf_lsm_h%ns)      )
+       ALLOCATE ( surf_lsm_h%vegetation_surface(1:surf_lsm_h%ns)  )
+       ALLOCATE ( surf_lsm_h%pavement_surface(1:surf_lsm_h%ns) )
+       ALLOCATE ( surf_lsm_h%qsws_soil(1:surf_lsm_h%ns)        )
+       ALLOCATE ( surf_lsm_h%qsws_liq(1:surf_lsm_h%ns)         )
+       ALLOCATE ( surf_lsm_h%qsws_veg(1:surf_lsm_h%ns)         )
        ALLOCATE ( surf_lsm_h%rad_net_l(1:surf_lsm_h%ns)        )
+       ALLOCATE ( surf_lsm_h%rho_c_def(1:surf_lsm_h%ns)        )  
        ALLOCATE ( surf_lsm_h%r_a(1:surf_lsm_h%ns)              )
        ALLOCATE ( surf_lsm_h%r_canopy(1:surf_lsm_h%ns)         )
@@ -2492,37 +2737,30 @@
        ALLOCATE ( surf_lsm_h%r_s(1:surf_lsm_h%ns)              )
        ALLOCATE ( surf_lsm_h%r_canopy_min(1:surf_lsm_h%ns)     )
-       ALLOCATE ( surf_lsm_h%shf_eb(1:surf_lsm_h%ns)           )
-       ALLOCATE ( surf_lsm_h%soil_type_2d(1:surf_lsm_h%ns)     )
-       ALLOCATE ( surf_lsm_h%veg_type_2d(1:surf_lsm_h%ns)      )
        ALLOCATE ( surf_lsm_h%water_surface(1:surf_lsm_h%ns)    )
 
-       surf_lsm_h%water_surface = .FALSE.
-       surf_lsm_h%pave_surface  = .FALSE.
+       surf_lsm_h%water_surface     = .FALSE.
+       surf_lsm_h%pavement_surface  = .FALSE.
+       surf_lsm_h%vegetation_surface   = .FALSE. 
 !
 !--    Vertical surfaces
        DO  l = 0, 3
-          ALLOCATE ( surf_lsm_v(l)%alpha_vg(1:surf_lsm_v(l)%ns)         )
           ALLOCATE ( surf_lsm_v(l)%building_surface(1:surf_lsm_v(l)%ns) )
           ALLOCATE ( surf_lsm_v(l)%c_liq(1:surf_lsm_v(l)%ns)            )
+          ALLOCATE ( surf_lsm_v(l)%c_surface(1:surf_lsm_v(l)%ns)        )
           ALLOCATE ( surf_lsm_v(l)%c_veg(1:surf_lsm_v(l)%ns)            )
           ALLOCATE ( surf_lsm_v(l)%f_sw_in(1:surf_lsm_v(l)%ns)          )
-          ALLOCATE ( surf_lsm_v(l)%ghf_eb(1:surf_lsm_v(l)%ns)           )
-          ALLOCATE ( surf_lsm_v(l)%gamma_w_sat(1:surf_lsm_v(l)%ns)      )
+          ALLOCATE ( surf_lsm_v(l)%ghf(1:surf_lsm_v(l)%ns)               )
           ALLOCATE ( surf_lsm_v(l)%g_d(1:surf_lsm_v(l)%ns)              )
           ALLOCATE ( surf_lsm_v(l)%lai(1:surf_lsm_v(l)%ns)              )
-          ALLOCATE ( surf_lsm_v(l)%l_vg(1:surf_lsm_v(l)%ns)             )
+          ALLOCATE ( surf_lsm_v(l)%lambda_h_def(1:surf_lsm_v(l)%ns)     )
           ALLOCATE ( surf_lsm_v(l)%lambda_surface_u(1:surf_lsm_v(l)%ns) )
           ALLOCATE ( surf_lsm_v(l)%lambda_surface_s(1:surf_lsm_v(l)%ns) )
-          ALLOCATE ( surf_lsm_v(l)%m_fc(1:surf_lsm_v(l)%ns)             )
-          ALLOCATE ( surf_lsm_v(l)%m_res(1:surf_lsm_v(l)%ns)            )
-          ALLOCATE ( surf_lsm_v(l)%m_sat(1:surf_lsm_v(l)%ns)            )
-          ALLOCATE ( surf_lsm_v(l)%m_wilt(1:surf_lsm_v(l)%ns)           )
-          ALLOCATE ( surf_lsm_v(l)%n_vg(1:surf_lsm_v(l)%ns)             )
-          ALLOCATE ( surf_lsm_v(l)%pave_surface(1:surf_lsm_v(l)%ns)     )
-          ALLOCATE ( surf_lsm_v(l)%qsws_eb(1:surf_lsm_v(l)%ns)          )
-          ALLOCATE ( surf_lsm_v(l)%qsws_soil_eb(1:surf_lsm_v(l)%ns)     )
-          ALLOCATE ( surf_lsm_v(l)%qsws_liq_eb(1:surf_lsm_v(l)%ns)      )
-          ALLOCATE ( surf_lsm_v(l)%qsws_veg_eb(1:surf_lsm_v(l)%ns)      )
+          ALLOCATE ( surf_lsm_v(l)%vegetation_surface(1:surf_lsm_v(l)%ns)  )
+          ALLOCATE ( surf_lsm_v(l)%pavement_surface(1:surf_lsm_v(l)%ns) )
+          ALLOCATE ( surf_lsm_v(l)%qsws_soil(1:surf_lsm_v(l)%ns)        )
+          ALLOCATE ( surf_lsm_v(l)%qsws_liq(1:surf_lsm_v(l)%ns)         )
+          ALLOCATE ( surf_lsm_v(l)%qsws_veg(1:surf_lsm_v(l)%ns)         )
           ALLOCATE ( surf_lsm_v(l)%rad_net_l(1:surf_lsm_v(l)%ns)        )
+          ALLOCATE ( surf_lsm_v(l)%rho_c_def(1:surf_lsm_h%ns)           )  
           ALLOCATE ( surf_lsm_v(l)%r_a(1:surf_lsm_v(l)%ns)              )
           ALLOCATE ( surf_lsm_v(l)%r_canopy(1:surf_lsm_v(l)%ns)         )
@@ -2531,11 +2769,10 @@
           ALLOCATE ( surf_lsm_v(l)%r_s(1:surf_lsm_v(l)%ns)              )
           ALLOCATE ( surf_lsm_v(l)%r_canopy_min(1:surf_lsm_v(l)%ns)     )
-          ALLOCATE ( surf_lsm_v(l)%shf_eb(1:surf_lsm_v(l)%ns)           )
-          ALLOCATE ( surf_lsm_v(l)%soil_type_2d(1:surf_lsm_v(l)%ns)     )
-          ALLOCATE ( surf_lsm_v(l)%veg_type_2d(1:surf_lsm_v(l)%ns)      )
           ALLOCATE ( surf_lsm_v(l)%water_surface(1:surf_lsm_v(l)%ns)    )
 
-          surf_lsm_v(l)%water_surface = .FALSE.
-          surf_lsm_v(l)%pave_surface  = .FALSE.
+          surf_lsm_v(l)%water_surface     = .FALSE.
+          surf_lsm_v(l)%pavement_surface  = .FALSE.
+          surf_lsm_v(l)%vegetation_surface   = .FALSE. 
+          
        ENDDO
    
@@ -2547,5 +2784,5 @@
        t_surface_h => t_surface_h_1; t_surface_h_p => t_surface_h_2
        m_soil_h    => m_soil_h_1;    m_soil_h_p    => m_soil_h_2
-       m_liq_eb_h  => m_liq_eb_h_1;  m_liq_eb_h_p  => m_liq_eb_h_2
+       m_liq_h  => m_liq_h_1;  m_liq_h_p  => m_liq_h_2
 !
 !--    Vertical surfaces
@@ -2553,5 +2790,5 @@
        t_surface_v => t_surface_v_1; t_surface_v_p => t_surface_v_2
        m_soil_v    => m_soil_v_1;    m_soil_v_p    => m_soil_v_2
-       m_liq_eb_v  => m_liq_eb_v_1;  m_liq_eb_v_p  => m_liq_eb_v_2
+       m_liq_v  => m_liq_v_1;  m_liq_v_p  => m_liq_v_2
 #endif
 
@@ -2574,4 +2811,5 @@
        NAMELIST /lsm_par/         alpha_vangenuchten, c_surface,               &
                                   canopy_resistance_coefficient,               &
+                                  constant_roughness,                          &
                                   conserve_water_content,                      &
                                   f_shortwave_incoming, field_capacity,        & 
@@ -2581,11 +2819,16 @@
                                   l_vangenuchten, min_canopy_resistance,       &
                                   min_soil_resistance, n_vangenuchten,         &
-                                  pave_depth, pave_heat_capacity,              &
-                                  pave_heat_conductivity,                      &
+                                  pavement_depth, pavement_heat_capacity,      &
+                                  pavement_heat_conduct, pavement_type,        &
                                   residual_moisture, root_fraction,            &
                                   saturation_moisture, skip_time_do_lsm,       &
                                   soil_moisture, soil_temperature, soil_type,  &
-                                  vegetation_coverage, veg_type, wilting_point,& 
-                                  zs, z0_eb, z0h_eb, z0q_eb
+                                  surface_type,                                &
+                                  vegetation_coverage, vegetation_type,        &
+                                  water_temperature, water_type,               &
+                                  wilting_point, zs, z0_vegetation,            &
+                                  z0h_vegetation, z0q_vegetation, z0_water,    &
+                                  z0h_water, z0q_water, z0_pavement,           &
+                                  z0h_pavement, z0q_pavement
        
        line = ' '
@@ -2668,16 +2911,11 @@
        DO  m = 1, surf%ns
 
-          IF ( surf%pave_surface(m) )  THEN
-             surf%rho_c_total(nzb_soil,m) = pave_heat_capacity
-             lambda_temp(nzb_soil)          = pave_heat_conductivity
-          ENDIF
-
           IF (  .NOT.  surf%water_surface(m) )  THEN
              DO  k = nzb_soil, nzt_soil
 
-                IF ( surf%pave_surface(m)  .AND.  zs(k) <= pave_depth )  THEN
+                IF ( surf%pavement_surface(m)  .AND.  zs(k) <= pavement_depth )  THEN
                     
-                   surf%rho_c_total(k,m) = pave_heat_capacity
-                   lambda_temp(k)        = pave_heat_conductivity   
+                   surf%rho_c_total(k,m) = surf%rho_c_def(m)
+                   lambda_temp(k)   = surf%lambda_h_def(m) 
 
                 ELSE            
@@ -2686,5 +2924,5 @@
 !--                into account water content 
                    surf%rho_c_total(k,m) = (rho_c_soil *                 &
-                                               ( 1.0_wp - surf%m_sat(m) )&
+                                               ( 1.0_wp - surf%m_sat(k,m) )&
                                                + rho_c_water * surf_m_soil%var_2d(k,m) )
 
@@ -2692,9 +2930,9 @@
 !--                Calculate soil heat conductivity at the center of the soil
 !--                layers
-                   lambda_h_sat = lambda_h_sm**(1.0_wp - surf%m_sat(m)) *&
+                   lambda_h_sat = lambda_h_sm**(1.0_wp - surf%m_sat(k,m)) *      &
                                   lambda_h_water ** surf_m_soil%var_2d(k,m)
 
-                   ke = 1.0_wp + LOG10( MAX( 0.1_wp, surf_m_soil%var_2d(k,m) /             &
-                                                     surf%m_sat(m) ) )
+                   ke = 1.0_wp + LOG10( MAX( 0.1_wp, surf_m_soil%var_2d(k,m) / &
+                                                     surf%m_sat(k,m) ) )
 
                    lambda_temp(k) = ke * (lambda_h_sat - lambda_h_dry) +       &
@@ -2704,18 +2942,20 @@
 
 !
-!--          Calculate soil heat conductivity (lambda_h) at the _stag level 
+!--          Calculate soil heat conductivity (lambda_h) at the _layer level 
 !--          using linear interpolation. For pavement surface, the
 !--          true pavement depth is considered
              DO  k = nzb_soil, nzt_soil-1
-                IF ( surf%pave_surface(m)  .AND.  zs(k)   < pave_depth   &
-                                                 .AND.  zs(k+1) > pave_depth )  THEN
-                   surf%lambda_h(k,m) = ( pave_depth - zs(k) ) / dz_soil(k+1)&
-                                     * lambda_temp(k)                          &
-                                     + ( 1.0_wp - ( pave_depth - zs(k) )       &
-                                     / dz_soil(k+1) ) * lambda_temp(k+1)
+                IF ( surf%pavement_surface(m)  .AND.  zs(k) < pavement_depth   &
+                     .AND.  zs(k+1) > pavement_depth )                         &
+                THEN
+                   surf%lambda_h(k,m) = ( pavement_depth - zs(k) ) * ddz_soil(k+1)   &
+                                      * lambda_temp(k)                               &
+                                      + ( zs(k+1) - pavement_depth ) * ddz_soil(k+1) &
+                                      * lambda_temp(k+1)
                 ELSE
-                   surf%lambda_h(k,m) = ( lambda_temp(k+1) + lambda_temp(k) )&
-                                     * 0.5_wp
+                   surf%lambda_h(k,m) = ( lambda_temp(k+1) + lambda_temp(k) )  &
+                                        * 0.5_wp
                 ENDIF
+
              ENDDO
              surf%lambda_h(nzt_soil,m) = lambda_temp(nzt_soil)
@@ -2725,18 +2965,18 @@
              tend(:) = 0.0_wp
 
-             tend(nzb_soil) = ( 1.0_wp / surf%rho_c_total(nzb_soil,m) ) *&
+             tend(nzb_soil) = ( 1.0_wp / surf%rho_c_total(nzb_soil,m) ) *            &
                     ( surf%lambda_h(nzb_soil,m) * ( surf_t_soil%var_2d(nzb_soil+1,m) &
-                      - surf_t_soil%var_2d(nzb_soil,m) ) * ddz_soil(nzb_soil+1)            &
-                      + surf%ghf_eb(m) ) * ddz_soil_stag(nzb_soil)
+                      - surf_t_soil%var_2d(nzb_soil,m) ) * ddz_soil(nzb_soil)        &
+                      + surf%ghf(m) ) * ddz_soil_layer(nzb_soil)
 
              DO  k = nzb_soil+1, nzt_soil
-                tend(k) = ( 1.0_wp / surf%rho_c_total(k,m) )             &
-                          * (   surf%lambda_h(k,m)                       &
-                              * ( surf_t_soil%var_2d(k+1,m) - surf_t_soil%var_2d(k,m) )                &
-                              * ddz_soil(k+1)                                  &
-                              - surf%lambda_h(k-1,m)                     &
-                              * ( surf_t_soil%var_2d(k,m) - surf_t_soil%var_2d(k-1,m) )                &
-                              * ddz_soil(k)                                    &
-                            ) * ddz_soil_stag(k)
+                tend(k) = ( 1.0_wp / surf%rho_c_total(k,m) )                            &
+                          * (   surf%lambda_h(k,m)                                      &
+                              * ( surf_t_soil%var_2d(k+1,m) - surf_t_soil%var_2d(k,m) ) &
+                              * ddz_soil(k)                                             &
+                              - surf%lambda_h(k-1,m)                                    &
+                              * ( surf_t_soil%var_2d(k,m) - surf_t_soil%var_2d(k-1,m) ) &
+                              * ddz_soil(k-1)                                           &
+                            ) * ddz_soil_layer(k)
 
              ENDDO
@@ -2769,40 +3009,31 @@
 !
 !--             Calculate soil diffusivity at the center of the soil layers
-                lambda_temp(k) = (- b_ch * surf%gamma_w_sat(m) * psi_sat     &
-                                  / surf%m_sat(m) ) * ( MAX( surf_m_soil%var_2d(k,m),    &
-                                  surf%m_wilt(m) ) / surf%m_sat(m) )**(&
+                lambda_temp(k) = (- b_ch * surf%gamma_w_sat(k,m) * psi_sat     &
+                                  / surf%m_sat(k,m) ) * ( MAX( surf_m_soil%var_2d(k,m),    &
+                                  surf%m_wilt(k,m) ) / surf%m_sat(k,m) )**(&
                                                             b_ch + 2.0_wp )
 
 !
 !--             Parametrization of Van Genuchten
-                IF ( soil_type /= 7 )  THEN
-!
-!--                Calculate the hydraulic conductivity after Van Genuchten 
-!--                (1980)
-                   h_vg = ( ( ( surf%m_res(m) - surf%m_sat(m) ) /  &
-                              ( surf%m_res(m) -                          &
-                                MAX( surf_m_soil%var_2d(k,m), surf%m_wilt(m) )       &
-                              )                                                &
-                            )**(                                               &
-                          surf%n_vg(m) / ( surf%n_vg(m) - 1.0_wp ) &
-                               ) - 1.0_wp                                      &
-                          )**( 1.0_wp / surf%n_vg(m) ) / surf%alpha_vg(m)
-
-                   gamma_temp(k) = surf%gamma_w_sat(m) * ( ( ( 1.0_wp +  &
-                          ( surf%alpha_vg(m) * h_vg )**surf%n_vg(m)&
+!--             Calculate the hydraulic conductivity after Van Genuchten (1980)
+                h_vg = ( ( ( surf%m_res(k,m) - surf%m_sat(k,m) ) /  &
+                           ( surf%m_res(k,m) -                          &
+                             MAX( surf_m_soil%var_2d(k,m), surf%m_wilt(k,m) )       &
+                           )                                                &
+                         )**(                                               &
+                       surf%n_vg(k,m) / ( surf%n_vg(k,m) - 1.0_wp ) &
+                            ) - 1.0_wp                                      &
+                       )**( 1.0_wp / surf%n_vg(k,m) ) / surf%alpha_vg(k,m)
+
+                gamma_temp(k) = surf%gamma_w_sat(k,m) * ( ( ( 1.0_wp +  &
+                       ( surf%alpha_vg(k,m) * h_vg )**surf%n_vg(k,m)&
                                                                )**(            &
-                              1.0_wp - 1.0_wp / surf%n_vg(m)) - (        &
-                          surf%alpha_vg(m) * h_vg )**( surf%n_vg(m)&
-                              - 1.0_wp) )**2 )                                 &
-                              / ( ( 1.0_wp + ( surf%alpha_vg(m) * h_vg   &
-                              )**surf%n_vg(m) )**( ( 1.0_wp  - 1.0_wp    &
-                              / surf%n_vg(m) ) *                         &
-                              ( surf%l_vg(m) + 2.0_wp) ) )
-!
-!--             Parametrization of Clapp & Hornberger
-                ELSE
-                   gamma_temp(k) = surf%gamma_w_sat(m) * ( surf_m_soil%var_2d(k,m)   &
-                                   / surf%m_sat(m) )**(2.0_wp * b_ch + 3.0_wp)
-                ENDIF
+                           1.0_wp - 1.0_wp / surf%n_vg(k,m)) - (        &
+                       surf%alpha_vg(k,m) * h_vg )**( surf%n_vg(k,m)&
+                           - 1.0_wp) )**2 )                                 &
+                           / ( ( 1.0_wp + ( surf%alpha_vg(k,m) * h_vg   &
+                           )**surf%n_vg(k,m) )**( ( 1.0_wp  - 1.0_wp    &
+                           / surf%n_vg(k,m) ) *                         &
+                           ( surf%l_vg(k,m) + 2.0_wp) ) )
 
              ENDDO
@@ -2812,7 +3043,7 @@
 !--          when humidity is enabled in the atmosphere and the surface type
 !--          is not pavement (implies dry soil below).
-             IF ( humidity  .AND.  .NOT.  surf%pave_surface(m) )  THEN
-!
-!--             Calculate soil diffusivity (lambda_w) at the _stag level 
+             IF ( humidity  .AND.  .NOT.  surf%pavement_surface(m) )  THEN
+!
+!--             Calculate soil diffusivity (lambda_w) at the _layer level 
 !--             using linear interpolation. To do: replace this with
 !--             ECMWF-IFS Eq. 8.81
@@ -2837,5 +3068,5 @@
                 ENDIF     
 
-!--             The root extraction (= root_extr * qsws_veg_eb / (rho_l     
+!--             The root extraction (= root_extr * qsws_veg / (rho_l     
 !--             * l_v)) ensures the mass conservation for water. The         
 !--             transpiration of plants equals the cumulative withdrawals by 
@@ -2852,5 +3083,5 @@
                 m_total = 0.0_wp
                 DO  k = nzb_soil, nzt_soil
-                    IF ( surf_m_soil%var_2d(k,m) > surf%m_wilt(m) )  THEN
+                    IF ( surf_m_soil%var_2d(k,m) > surf%m_wilt(k,m) )  THEN
                        m_total = m_total + surf%root_fr(k,m) * surf_m_soil%var_2d(k,m)
                     ENDIF
@@ -2858,5 +3089,5 @@
                  IF ( m_total > 0.0_wp )  THEN
                    DO  k = nzb_soil, nzt_soil
-                      IF ( surf_m_soil%var_2d(k,m) > surf%m_wilt(m) )  THEN
+                      IF ( surf_m_soil%var_2d(k,m) > surf%m_wilt(k,m) )  THEN
                          root_extr(k) = surf%root_fr(k,m) * surf_m_soil%var_2d(k,m)  &
                                                             / m_total
@@ -2872,19 +3103,19 @@
                 tend(nzb_soil) = ( surf%lambda_w(nzb_soil,m) *   (       &
                          surf_m_soil%var_2d(nzb_soil+1,m) - surf_m_soil%var_2d(nzb_soil,m) )           &
-                         * ddz_soil(nzb_soil+1) - surf%gamma_w(nzb_soil,m) - &
+                         * ddz_soil(nzb_soil) - surf%gamma_w(nzb_soil,m) - &
                                                      (                         &
-                            root_extr(nzb_soil) * surf%qsws_veg_eb(m)    &
-                            + surf%qsws_soil_eb(m) ) * drho_l_lv )       &
-                            * ddz_soil_stag(nzb_soil)
+                            root_extr(nzb_soil) * surf%qsws_veg(m)    &
+                            + surf%qsws_soil(m) ) * drho_l_lv )       &
+                            * ddz_soil_layer(nzb_soil)
 
                 DO  k = nzb_soil+1, nzt_soil-1
                    tend(k) = ( surf%lambda_w(k,m) * ( surf_m_soil%var_2d(k+1,m)      &
-                             - surf_m_soil%var_2d(k,m) ) * ddz_soil(k+1)                   &
+                             - surf_m_soil%var_2d(k,m) ) * ddz_soil(k)                   &
                              - surf%gamma_w(k,m)                         &
                              - surf%lambda_w(k-1,m) * ( surf_m_soil%var_2d(k,m) -    &
-                             surf_m_soil%var_2d(k-1,m)) * ddz_soil(k)                      &
+                             surf_m_soil%var_2d(k-1,m)) * ddz_soil(k-1)                      &
                              + surf%gamma_w(k-1,m) - (root_extr(k)       &
-                             * surf%qsws_veg_eb(m) * drho_l_lv)          &
-                             ) * ddz_soil_stag(k)
+                             * surf%qsws_veg(m) * drho_l_lv)          &
+                             ) * ddz_soil_layer(k)
                 ENDDO
                 tend(nzt_soil) = ( - surf%gamma_w(nzt_soil,m)            &
@@ -2892,9 +3123,9 @@
                                      * ( surf_m_soil%var_2d(nzt_soil,m)                    &
                                      - surf_m_soil%var_2d(nzt_soil-1,m))                   &
-                                     * ddz_soil(nzt_soil)                      &
+                                     * ddz_soil(nzt_soil-1)                      &
                                      + surf%gamma_w(nzt_soil-1,m) - (    &
                                        root_extr(nzt_soil)                     &
-                                     * surf%qsws_veg_eb(m) * drho_l_lv ) &
-                                  ) * ddz_soil_stag(nzt_soil)             
+                                     * surf%qsws_veg(m) * drho_l_lv ) &
+                                  ) * ddz_soil_layer(nzt_soil)             
 
                 surf_m_soil_p%var_2d(nzb_soil:nzt_soil,m) = surf_m_soil%var_2d(nzb_soil:nzt_soil,m)    &
@@ -2950,5 +3181,5 @@
        IF ( humidity )  THEN
           m_soil_h    = m_soil_h_p
-          m_liq_eb_h  = m_liq_eb_h_p
+          m_liq_h  = m_liq_h_p
        ENDIF
 !
@@ -2958,5 +3189,5 @@
        IF ( humidity )  THEN
           m_soil_v    = m_soil_v_p
-          m_liq_eb_v  = m_liq_eb_v_p
+          m_liq_v  = m_liq_v_p
        ENDIF
 
@@ -2972,5 +3203,5 @@
              IF ( humidity )  THEN
                 m_soil_h    => m_soil_h_1;   m_soil_h_p    => m_soil_h_2
-                m_liq_eb_h  => m_liq_eb_h_1; m_liq_eb_h_p  => m_liq_eb_h_2
+                m_liq_h  => m_liq_h_1; m_liq_h_p  => m_liq_h_2
              ENDIF
 !
@@ -2980,5 +3211,5 @@
              IF ( humidity )  THEN
                 m_soil_v    => m_soil_v_1;   m_soil_v_p    => m_soil_v_2
-                m_liq_eb_v  => m_liq_eb_v_1; m_liq_eb_v_p  => m_liq_eb_v_2
+                m_liq_v  => m_liq_v_1; m_liq_v_p  => m_liq_v_2
              ENDIF
 
@@ -2992,5 +3223,5 @@
              IF ( humidity )  THEN
                 m_soil_h    => m_soil_h_2;   m_soil_h_p    => m_soil_h_1
-                m_liq_eb_h  => m_liq_eb_h_2; m_liq_eb_h_p  => m_liq_eb_h_1
+                m_liq_h  => m_liq_h_2; m_liq_h_p  => m_liq_h_1
              ENDIF
 !
@@ -3000,5 +3231,5 @@
              IF ( humidity )  THEN
                 m_soil_v    => m_soil_v_2;   m_soil_v_p    => m_soil_v_1
-                m_liq_eb_v  => m_liq_eb_v_2; m_liq_eb_v_p  => m_liq_eb_v_1
+                m_liq_v  => m_liq_v_2; m_liq_v_p  => m_liq_v_1
              ENDIF
 
@@ -3058,9 +3289,9 @@
                 c_veg_av = 0.0_wp
 
-             CASE ( 'ghf_eb*' )
-                IF ( .NOT. ALLOCATED( ghf_eb_av ) )  THEN
-                   ALLOCATE( ghf_eb_av(nysg:nyng,nxlg:nxrg) )
+             CASE ( 'ghf*' )
+                IF ( .NOT. ALLOCATED( ghf_av ) )  THEN
+                   ALLOCATE( ghf_av(nysg:nyng,nxlg:nxrg) )
                 ENDIF
-                ghf_eb_av = 0.0_wp
+                ghf_av = 0.0_wp
 
              CASE ( 'lai*' )
@@ -3070,9 +3301,9 @@
                 lai_av = 0.0_wp
 
-             CASE ( 'm_liq_eb*' )
-                IF ( .NOT. ALLOCATED( m_liq_eb_av ) )  THEN
-                   ALLOCATE( m_liq_eb_av(nysg:nyng,nxlg:nxrg) )
+             CASE ( 'm_liq*' )
+                IF ( .NOT. ALLOCATED( m_liq_av ) )  THEN
+                   ALLOCATE( m_liq_av(nysg:nyng,nxlg:nxrg) )
                 ENDIF
-                m_liq_eb_av = 0.0_wp
+                m_liq_av = 0.0_wp
 
              CASE ( 'm_soil' )
@@ -3082,27 +3313,21 @@
                 m_soil_av = 0.0_wp
 
-             CASE ( 'qsws_eb*' )
-                IF ( .NOT. ALLOCATED( qsws_eb_av ) )  THEN
-                   ALLOCATE( qsws_eb_av(nysg:nyng,nxlg:nxrg) )
+             CASE ( 'qsws_liq*' )
+                IF ( .NOT. ALLOCATED( qsws_liq_av ) )  THEN
+                   ALLOCATE( qsws_liq_av(nysg:nyng,nxlg:nxrg) )
                 ENDIF
-                qsws_eb_av = 0.0_wp
-
-             CASE ( 'qsws_liq_eb*' )
-                IF ( .NOT. ALLOCATED( qsws_liq_eb_av ) )  THEN
-                   ALLOCATE( qsws_liq_eb_av(nysg:nyng,nxlg:nxrg) )
+                qsws_liq_av = 0.0_wp
+
+             CASE ( 'qsws_soil*' )
+                IF ( .NOT. ALLOCATED( qsws_soil_av ) )  THEN
+                   ALLOCATE( qsws_soil_av(nysg:nyng,nxlg:nxrg) )
                 ENDIF
-                qsws_liq_eb_av = 0.0_wp
-
-             CASE ( 'qsws_soil_eb*' )
-                IF ( .NOT. ALLOCATED( qsws_soil_eb_av ) )  THEN
-                   ALLOCATE( qsws_soil_eb_av(nysg:nyng,nxlg:nxrg) )
+                qsws_soil_av = 0.0_wp
+
+             CASE ( 'qsws_veg*' )
+                IF ( .NOT. ALLOCATED( qsws_veg_av ) )  THEN
+                   ALLOCATE( qsws_veg_av(nysg:nyng,nxlg:nxrg) )
                 ENDIF
-                qsws_soil_eb_av = 0.0_wp
-
-             CASE ( 'qsws_veg_eb*' )
-                IF ( .NOT. ALLOCATED( qsws_veg_eb_av ) )  THEN
-                   ALLOCATE( qsws_veg_eb_av(nysg:nyng,nxlg:nxrg) )
-                ENDIF
-                qsws_veg_eb_av = 0.0_wp
+                qsws_veg_av = 0.0_wp
 
              CASE ( 'r_a*' )
@@ -3118,10 +3343,4 @@
                 r_s_av = 0.0_wp
 
-             CASE ( 'shf_eb*' )
-                IF ( .NOT. ALLOCATED( shf_eb_av ) )  THEN
-                   ALLOCATE( shf_eb_av(nysg:nyng,nxlg:nxrg) )
-                ENDIF
-                shf_eb_av = 0.0_wp
-
              CASE ( 't_soil' )
                 IF ( .NOT. ALLOCATED( t_soil_av ) )  THEN
@@ -3160,9 +3379,9 @@
              ENDDO
 
-          CASE ( 'ghf_eb*' )
+          CASE ( 'ghf*' )
              DO  m = 1, surf_lsm_h%ns
                 i   = surf_lsm_h%i(m)            
                 j   = surf_lsm_h%j(m)
-                ghf_eb_av(j,i) = ghf_eb_av(j,i) + surf_lsm_h%ghf_eb(m)
+                ghf_av(j,i) = ghf_av(j,i) + surf_lsm_h%ghf(m)
              ENDDO
 
@@ -3174,9 +3393,9 @@
              ENDDO
 
-          CASE ( 'm_liq_eb*' )
+          CASE ( 'm_liq*' )
              DO  m = 1, surf_lsm_h%ns
                 i   = surf_lsm_h%i(m)            
                 j   = surf_lsm_h%j(m)
-                m_liq_eb_av(j,i) = m_liq_eb_av(j,i) + m_liq_eb_h%var_1d(m)
+                m_liq_av(j,i) = m_liq_av(j,i) + m_liq_h%var_1d(m)
              ENDDO
 
